<?php

/* DISCLAIMER *****************************************************************
*                                                                             *
* The Purple Yin Guestbook code is distributed without any warranty. All      *
* warranties, expressed or implied are hereby disclaimed. This includes but   *
* is not limited to warranties of merchantability or fitness for a particular *
* purpose. The reselling of this code is strictly prohibited.                 *
*                                                                             *
*******************************************************************************

/* PURPLE YIN GUESTBOOK INFORMATION *******************************************
*                                                                             *
* URL:           www.purpleyin.com                                            *
* AUTHOR:        Thomas Phan                                                  *
*                                                                             *
******************************************************************************/

include'PYG.php';

if($options->get('passwordProtect'))
{
	session_start();

	$storedPassword=new PYGPASSWORD();

	if($storedPassword->present())
	{
		if(!isset($_SERVER['QUERY_STRING']))
		{
			$_SERVER['QUERY_STRING']='';
		}

		if(isset($_POST['post_password']))
		{
			$_SESSION['sessUserPassword']=$storedPassword->crypt($_POST['post_password']);

			if($storedPassword->get()==$_SESSION['sessUserPassword'])
			{
				/*
				Turn off password protection if password protection
				checkbox is unchecked.
				*/
				if(!isset($_POST['post_passwordProtect']))
				{
					$options->toggle('passwordProtect');
				}
			}
			else
			{
				/*
				Clear session password and redirect so
				that the login form will be displayed.
				*/
				$_SESSION=array();
				
				session_destroy();
				
				header('location: admin.php?'.$_SERVER['QUERY_STRING']);
				
				exit();
			}
		}
		elseif(isset($_SESSION['sessUserPassword']))
		{
			if($storedPassword->get()!=$_SESSION['sessUserPassword'])
			{
				/*
				Clear session password and redirect so
				that the login form will be displayed.
				*/
				$_SESSION=array();
				
				session_destroy();
				
				header('location: admin.php?'.$_SERVER['QUERY_STRING']);
				
				exit();
			}
		}
		else
		{
			/* Display login form. */
			$templates=new PYGTEMPLATES();
			
			$temp=$templates->get('login');
			
			$temp=str_replace('<scriptName>',GUESTBOOK_NAME,$temp);
			
			$temp=str_replace('<action>',str_replace('&','&amp;','admin.php?'.$_SERVER['QUERY_STRING']),$temp);

			print$temp;
			
			exit();
			/* End: Display login form. */
		}
	}
	elseif(
		isset($_POST['post_password'])&&
		isset($_POST['post_confirmPassword'])&&
		strlen($_POST['post_password'])>0&&
		strlen($_POST['post_confirmPassword'])>0
	)
	{
		if($_POST['post_password']==$_POST['post_confirmPassword'])
		{
			$storedPassword->set($_POST['post_password']);
			
			/* Redirect so that login form will be displayed. */
			header('location: admin.php');
			
			exit();
		}
		else
		{
			print'Passwords do not match. Use your browser\'s "back" button and try again';
			
			exit();
		}
	}
	else
	{
		/* Display "Set Password" form. */
		?>
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title><?php print GUESTBOOK_NAME;?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<style type="text/css">
		<!--
		body {
			font-family: 		Arial, Helvetica, sans-serif;
			font-size: 		8pt;
			background-color: 	#666699;
			color: 			#000000;
		}
		.pyg_button {
			font-family: 		Arial, Helvetica, sans-serif;
			font-size: 		8pt;
		}
		.pyg_table {
			border:			4px solid #000000;
			background-color:	#FFFFFF;
		}
		.pyg_table_header {
			background-color: 	#DEE3E7;
			color: 			#000000;
			font-weight: 		bold;
		}
		.pyg_table_header_2 {
			background-color: 	#DEE3E7;
		}
		.pyg_table_body {
			background-color: 	#FFFFFF;
			color: 			#000000;
		}
		a {
			text-decoration: 	none;
			color: 			#0000FF;
		}
		-->
		</style>
		</head>
		<body>
		<table cellspacing ="4" cellpadding="4" align="center">
		<tr align="center">
		<td>
		<p align="center" style="font-weight:bold;color:#FFFFFF;"><?php print GUESTBOOK_NAME;?></p>
		</td>
		</tr>
		<tr>
		<td>
		<table width="100" align="center" cellpadding="4" cellspacing="4" class="pyg_table">
		<tr><td class="pyg_table_header">Set Password</td></tr>
		<tr><td class="pyg_table_body">
		<form name="form1" id="form1" method="post" action="admin.php">
		<p>Password
		<input name="post_password" type="password" id="post_password" /></p>
		<p>Confirm Password
		<input name="post_confirmPassword" type="password" id="post_confirmPassword" /></p>
		<p><input name="Submit" type="submit" class="pyg_button" value="Submit" /></p>
		</form>
		</td></tr>
		</table>
		</td>
		</tr>
		</table>
		</body>
		</html>
		<?php

		exit();
	}
}

if(isset($_GET['action']))
{
	switch($_GET['action'])
	{
		case'logout':
			$_SESSION=array();
			session_destroy();
			header('location: admin.php');
		break;
		case'toggleRequired':
			$fields=new PYGFIELDS();
			$fields->toggleRequired($_GET['field']);
			header('location: admin.php?display=signAdmin');
		break;
		case'addBadWord':
			$badWords=new PYGBADWORDS();
			$badWords->add($_POST['badWord']);
			header('location: admin.php?display=signAdmin');
		break;
		case'addBadString':
			$badStrings=new PYGBADSTRINGS();
			$badStrings->add($_POST['badString']);
			header('location: admin.php?display=signAdmin');
		break;
		case'removeBadWord':
			$badWords=new PYGBADWORDS();
			$badWords->remove($_GET['badWord']);
			header('location: admin.php?display=signAdmin');
		break;
		case'removeBadString':
			$badStrings=new PYGBADSTRINGS();
			$badStrings->remove($_GET['badString']);
			header('location: admin.php?display=signAdmin');
		break;
		case'ban':
			if(isset($_GET['ip']))
			{
				$bannedIPs=new PYGBANNEDIPS();
				$bannedIPs->add($_GET['ip']);
				header('location: admin.php?status='.$_GET['status'].'&display=adminEntries&beginningEntry='.$_GET['beginningEntry']);
			}
			else
			{
				$bannedIPs=new PYGBANNEDIPS();
				$bannedIPs->add($_POST['ip']);
				header('location: admin.php?display=signAdmin');
			}
		break;
		case'unban':
			if(isset($_GET['beginningEntry']))
			{
				$bannedIPs=new PYGBANNEDIPS();
				$bannedIPs->remove($_GET['ip']);
				header('location: admin.php?status='.$_GET['status'].'&display=adminEntries&beginningEntry='.$_GET['beginningEntry']);
			}
			else
			{
				$bannedIPs=new PYGBANNEDIPS();
				$bannedIPs->remove($_GET['ip']);
				header('location: admin.php?display=signAdmin');
			}
		break;
		case'setMaxWordLength':
			$options->set('maxWordLength',$_POST['maxWordLength']);
			header('location: admin.php?display=viewAdmin');
		break;
		case'toggleSpanPages':
			$options->toggle('spanPages');
			header('location: admin.php?display=viewAdmin');
		break;
		case'setEntriesPerPage':
			$options->set('entriesPerPage',$_POST['entriesPerPage']);
			header('location: admin.php?display=viewAdmin');
		break;
		case'toggleEntryOrder':
			$options->toggle('entryOrder');
			header('location: admin.php?display=viewAdmin');
		break;
		case'setEmptyGoTo':
			$options->set('emptyGoTo',$_POST['emptyGoTo']);
			header('location: admin.php?display=viewAdmin');
		break;
		case'toggleSmilies':
			$options->toggle('smiliesEnabled');
			header('location: admin.php?display=viewAdmin');
		break;
		case'toggleHostName':
			$options->toggle('hostNameByIP');
			header('location: admin.php?display=viewAdmin');
		break;
		case'addSmiley':
			$smileyList=new PYGSMILIES();
			$smileyList->add(
				$_POST['emoticon'],
				$_POST['filename'],
				$_POST['advanced']
			);
			header('location: admin.php?display=viewAdmin');
		break;
		case'removeSmiley':
			$smilies=new PYGSMILIES();
			$smilies->remove($_GET['ID']);
			header('location: admin.php?display=viewAdmin');
		break;
		case'deleteEntry':
			$DB=new PYGDB();
			$DB->delete($_GET['id']);
			header('location: '.$_GET['from'].'.php?display=adminEntries&status='.$_GET['status'].'&beginningEntry='.$_GET['beginningEntry']);
		break;
		case'permanentlyDeleteEntry':
			header('location: admin.php?display=adminDeleted');
		break;
		case'restore':
			header('location: admin.php?display=adminDeleted');
		break;
		case'editEntry':
			$DB=new PYGDB();
			$_POST['dateAndTime']=mktime($_POST['hour'],$_POST['minute'],$_POST['second'],$_POST['month'],$_POST['day'],$_POST['year']);
			if(!isset($_POST['private']))
			{
				$_POST['private']=0;
			}
			$DB->update($_POST);
			header("location: {$_GET['from']}.php?status={$_GET['status']}&display=adminEntries&beginningEntry={$_GET['beginningEntry']}");
		break;
		case'makeActive':
			$DB=new PYGDB();
			$DB->update($_GET['id'],'status',1);
			header("location: admin.php?status={$_GET['status']}&display=adminEntries&beginningEntry={$_GET['beginningEntry']}");
		break;
		case'reply':
			$DB=new PYGDB();
			$entry=$DB->select($_GET['id']);
			$entry['reply']=$_POST['reply'];
			$DB->update($entry);
			header('location: '.$_GET['from'].'.php?status='.$_GET['status'].'&display=adminEntries&beginningEntry='.$_GET['beginningEntry']);
		break;
		case'advDBEdit':
			header('location: admin.php?display=advDBEdit');
		break;
		case'toggleEmailNotification':
			$options->toggle('emailNotification');
			header('location: admin.php?display=otherAdmin');
		break;
		case'setAdminEmail':
			$options->set('adminEmail',$_POST['post_adminEmail']);
			header('location: admin.php?display=otherAdmin');
		break;
		case'setTimeOffset':
			$options->set('timeOffset',$_POST['seconds']);
			header('location: admin.php?display=signAdmin');
		break;
		case'setMaxEntryLength':
			$options->set('maxEntryLength',$_POST['characters']);
			header('location: admin.php?display=signAdmin');
		break;
		case'setMaxLines':
			$options->set('maxLines',$_POST['post_lines']);
			header('location: admin.php?display=signAdmin');
		break;
		case'setSignGoTo':
			$options->set('signGoTo',$_POST['signGoTo']);
			header('location: admin.php?display=signAdmin');
		break;
		case'editSign':
			$templates=new PYGTEMPLATES();
			$templates->set('sign',$_POST['post_signTemplate']);
			header('location: admin.php?display=signTemplateEditor');
		break;
		case'editThanks':
			$templates=new PYGTEMPLATES();
			$templates->set('thanks',$_POST['post_thanksTemplate']);
			header('location: admin.php?display=thanksTemplateEditor');
		break;
		case'editView':
			$templates=new PYGTEMPLATES();
			$templates->set('viewHeader',$_POST['post_headerTemplate']);
			$templates->set('viewEntry',$_POST['post_entryTemplate']);
			$templates->set('viewFooter',$_POST['post_footerTemplate']);
			header('location: admin.php?display=viewTemplateEditor');
		break;
		case'editReplyTemplate':
			$templates=new PYGTEMPLATES();
			$templates->set('reply',$_POST['post_replyTemplate']);
			header('location: admin.php?display=replyTemplateEditor');
		break;
		case'editLoginTemplate':
			$templates=new PYGTEMPLATES();
			$templates->set('login',$_POST['post_loginTemplate']);
			header('location: admin.php?display=loginTemplateEditor');
		break;
		case'editError':
			$templates=new PYGTEMPLATES();
			$templates->set('errorHeader',$_POST['post_errorHeaderTemplate']);
			$templates->set('perError',$_POST['post_perErrorTemplate']);
			$templates->set('errorFooter',$_POST['post_errorFooterTemplate']);
			header('location: admin.php?display=errorTemplateEditor');
		break;
		case'togglePasswordProtect':
			$options->toggle('passwordProtect');
			header('location: admin.php');
		break;
		case'toggleAllowHTML':
			$options->toggle('allowHTML');
			header('location: admin.php?display=viewAdmin');
		break;
		case'togglePrivatePlaceholders':
			$options->toggle('privatePlaceholders');
			header('location: admin.php?display=viewAdmin');
		break;
		case'toggleEntryNumbersOrder':
			$options->toggle('entryNumbersOrder');
			header('location: admin.php?display=viewAdmin');
		break;
		case'toggleEntryValidation':
			$options->toggle('validationRequired');
			header('location: admin.php?display=signAdmin');
		break;
		case'updateMonth':
			$options->set('month'.$_POST['post_monthNumber'],$_POST['post_monthName']);
			header('location: admin.php?display=languageAdmin');
		break;
		case'updateDay':
			$options->set('day'.$_POST['post_dayNumber'],$_POST['post_dayName']);
			header('location: admin.php?display=languageAdmin');
		break;
		case'setErrorMessage':
			$options->set($_POST['post_errorName'],$_POST['post_errorMessage']);
			header('location: admin.php?display=languageAdmin');
		break;
		case'resetPassword':
			$password=new PYGPASSWORD();
			$password->reset();
			header('location: admin.php');
		break;
	}
}
elseif(isset($_GET['display']))
{
	$guestbookName=GUESTBOOK_NAME;
	
	$adminHeader=<<<ADMINHEADERIDENTIFIER
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<title>$guestbookName</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<style type="text/css">
	<!--
	body {
		font-family: 		Arial, Helvetica, sans-serif;
		font-size: 			8pt;
		background-color: 	#666699;
		color: 				#000000;
	}
	.pyg_button {
		font-family: 		Arial, Helvetica, sans-serif;
		font-size: 			8pt;
	}
	.pyg_table {
		border:				4px solid #000000;
		background-color:	#FFFFFF;
	}
	.pyg_table_header {
		background-color: 	#DEE3E7;
		color: 				#000000;
		font-weight: 		bold;
	}
	.pyg_table_header_2 {
		background-color: 	#DEE3E7;
	}
	.pyg_table_body {
		background-color: 	#FFFFFF;
		color: 				#000000;
	}
	a {
		text-decoration: 	none;
		color: 				#0000FF;
	}
	-->
	</style>
	</head>
	<body>
	<table cellspacing ="4" cellpadding="4" align="center">
	<tr align="center">
	<td></td><td><a href="http://purpleyin.com"><p style="font-weight:bold;color:#FFFFFF;">$guestbookName</p></a></td>
	</tr>
	<tr>
	<td valign="top">
	
	<table width="100" cellspacing="4" cellpadding="4" class="pyg_table">
	<tr><td class="pyg_table_header">Main Menu</td></tr>
	<tr><td class="pyg_table_body">
	<p>
	<a href="admin.php?display=signAdmin">Sign</a><br />
	<a href="admin.php?display=viewAdmin">View</a><br />
	<a href="admin.php?display=adminEntries&amp;status=active">Entries</a><br />
	<a href="admin.php?display=templateAdmin">Templates</a><br />
	<a href="admin.php?display=languageAdmin">Language</a><br />
	<a href="admin.php?display=otherAdmin">Other</a>
	</p>
	<p>
	<a href="sign.php">Sign Page</a><br />
	<a href="view.php">View Page</a>
	<a href="thanks.php">Thanks Page</a>
	</p>
	<p><a href="admin.php?action=logout">Log Out</a></p>
	</td></tr>
	</table>
	
	</td>
	<td valign="top">
ADMINHEADERIDENTIFIER;

	/* Do not display logout button if password protection is turned off. */
	if(!$options->get('passwordProtect'))
	{
		$adminHeader=str_replace('<a href="admin.php?action=logout">Log Out</a>','Password protection is off. <a href="admin.php?action=togglePasswordProtect">Click here to turn on</a>.',$adminHeader);
	}

	$adminFooter=<<<ADMINFOOTERIDENTIFIER
	</td>
	</tr>
	</table>
	</body>
	</html>
ADMINFOOTERIDENTIFIER;

	/* Define tags for view template. */
	$entryTagDescriptions=array();

	$entryTagDescriptions['mo']='Numeric representation of the month. For example: 1, 2, ... 12';
	$entryTagDescriptions['modd']='Numeric representation of the month in 2-digit format. For example: 01, 02, ... 12';
	$entryTagDescriptions['month']='Name of month. For example: January';
	$entryTagDescriptions['weekday']='Name of Day. For example: Sunday';
	$entryTagDescriptions['da']='Day of month. For example: 1, 2, ... 31';
	$entryTagDescriptions['dadd']='Day of month in 2-digit format. For example: 01, 02, ... 31';
	$entryTagDescriptions['ye']='Year in 4-digit format. For example: 2001';
	$entryTagDescriptions['yedd']='Year in 2-digit format. For example: 02';
	$entryTagDescriptions['ho']='Hour. For example: 0, 1, ... 23';
	$entryTagDescriptions['hodd']='Hour in 2-digit format. For example: 00, 01, ... 23';
	$entryTagDescriptions['ampm']='am or pm.';
	$entryTagDescriptions['ho12']='Hour in 12-hour format.';
	$entryTagDescriptions['ho12dd']='Hour in 12-hour format (2-digit)';
	$entryTagDescriptions['mi']='Minutes. For example: 0, 1, ... 59';
	$entryTagDescriptions['midd']='Minutes in 2-digit format. For example: 00, 01, ... 59';
	$entryTagDescriptions['se']='Seconds. For example: 0, 1, ... 59';
	$entryTagDescriptions['sedd']='Seconds in 2-digit format. For example: 00, 01, ... 59';
	$entryTagDescriptions['number']='Entry number.';
	$entryTagDescriptions['name']='Name.';
	$entryTagDescriptions['email']='Email.';
	$entryTagDescriptions['emailJS']='Email displayed as JavaScript.';
	$entryTagDescriptions['emailLinked']='Displays email as a link.';
	$entryTagDescriptions['emailLinkedJS']='JavaScript is used to display email as a link .';
	$entryTagDescriptions['emailIcon']='Displays email as a linked icon.';
	$entryTagDescriptions['emailIconJS']='JavaScript is used to display email as a linked icon.';
	$entryTagDescriptions['homepage']='Homepage URL.';
	$entryTagDescriptions['homepageLinked']='Displays homepage URL as a link.';
	$entryTagDescriptions['homepageIcon']='Displays homepage as a linked icon.';
	$entryTagDescriptions['homepageIconBlank']='Displays homepage as a linked icon that opens up in _blank window.';
	$entryTagDescriptions['homepageIconTop']='Displays homepage as a linked icon that opens up in same window but on _top.';
	$entryTagDescriptions['location']='Location.';
	$entryTagDescriptions['comments']='Comments.';
	$entryTagDescriptions['ip']='IP address.';
	$entryTagDescriptions['reply']='Reply template with reply text.';
	$entryTagDescriptions['extraField1']='1st extra field.';
	$entryTagDescriptions['extraField2']='2nd extra field.';
	$entryTagDescriptions['extraField3']='3rd extra field.';
	$entryTagDescriptions['extraField4']='4th extra field.';
	$entryTagDescriptions['extraField5']='5th extra field.';
	$entryTagDescriptions['id']='id.';
	$entryTagDescriptions['deleteURL']='URL to delete current entry.';
	$entryTagDescriptions['editURL']='URL to edit current entry.';
	$entryTagDescriptions['replyURL']='URL to reply to current entry.';

	$anywhereTagDescriptions=array();

	$anywhereTagDescriptions['total']='Total number of entries.';
	$anywhereTagDescriptions['beginning']='Number of first entry currently displayed.';
	$anywhereTagDescriptions['ending']='Number of last entry currently displayed';
	$anywhereTagDescriptions['bNextPage']='Number of first entry on next page.';
	$anywhereTagDescriptions['eNextPage']='Number of last entry on next page.';
	$anywhereTagDescriptions['bPreviousPage']='Number of first entry on previous page.';
	$anywhereTagDescriptions['ePreviousPage']='Number of  last entry on previous page.';
	$anywhereTagDescriptions['nextURL']='URL to next page';
	$anywhereTagDescriptions['prevURL']='URL to previous page';
	$anywhereTagDescriptions['scriptName']='The name of this script.';
	$anywhereTagDescriptions['hostName']='The Internet host name of the corresponding IP address.';

	$anywhereTags=array_keys($anywhereTagDescriptions);

	$entryTags=array_keys($entryTagDescriptions);
	
	/* Define tags for the sign template. */
	$anywhereTagDescriptions_sign=array();
	
	$anywhereTagDescriptions_sign['total']='Total number of entries.';
	$anywhereTagDescriptions_sign['smilies']='List of clickable smilies.';
	$anywhereTagDescriptions_sign['scriptName']='The name of this script.';

	$anywhereTags_sign=array_keys($anywhereTagDescriptions_sign);
	
	/* Define tags for the login template. */
	$anywhereTagDescriptions_login=array();
	
	$anywhereTagDescriptions_login['scriptName']='The name of this script.';
	$anywhereTagDescriptions_login['action']='Value for action attribute of login form.';
	
	$anywhereTags_login=array_keys($anywhereTagDescriptions_login);
	
	/* Define tags for the thanks template. */
	$anywhereTagDescriptions_thanks=array();
	
	$anywhereTagDescriptions_thanks['scriptName']='The name of this script.';

	$anywhereTags_thanks=array_keys($anywhereTagDescriptions_thanks);
	
	/* Define tags for the reply template. */
	$anywhereTagDescription_reply=array();
	
	$anywhereTagDescriptions_reply['reply']='The reply text.';
	
	$anywhereTags_reply=array_keys($anywhereTagDescriptions_reply);
	
	/* Define tags for the error template. */
	$errorTagDescriptions_error=array();
	
	$errorTagDescriptions_error['error']='The error.';
	
	$anywhereTagDescriptions_error=array();
	
	$anywhereTagDescriptions_error['scriptName']='The name of this script.';
	
	$errorTags_error=array_keys($errorTagDescriptions_error);
	
	$anywhereTags_error=array_keys($anywhereTagDescriptions_error);
	
	switch($_GET["display"])
	{
/******************************************************************************
*******************************************************************************
*
* Display template administration menu.
*
*******************************************************************************
******************************************************************************/
		case'templateAdmin':
			print$adminHeader;
			
			?>
			<table width="650"  cellpadding="4" cellspacing="4" class="pyg_table">
			<tr><td class="pyg_table_header">Template Administration</td></tr>
			<tr>
			<td class="pyg_table_body">
			<p><a href="admin.php?display=viewTemplateEditor">View</a></p>
			<p><a href="admin.php?display=signTemplateEditor">Sign</a></p>
			<p><a href="admin.php?display=errorTemplateEditor">Error</a></p>
			<p><a href="admin.php?display=replyTemplateEditor">Reply</a></p>
			<p><a href="admin.php?display=thanksTemplateEditor">Thanks</a></p>
			<p><a href="admin.php?display=loginTemplateEditor">Login</a></p>
			</td>
			</tr>
			</table>
			<?php
			
			print$adminFooter;
		break;
/******************************************************************************
Display view template editor.
******************************************************************************/
		case 'viewTemplateEditor':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			</head>
			<frameset rows="*" cols="150,*" border="0" framespacing="0">
				<frame src="admin.php?display=displayLeftView" name="left" id="left" />
				<frameset rows="50,*" border="0" framespacing="0">
					<frame src="admin.php?display=displayTopView" name="top" id="top" />
					<frame src="admin.php?display=displayRightView" name="right" id="right" />
				</frameset>
			</frameset>
			<noframes>
			<body>
			</body>
			</noframes>
			</html>
			<?php
		break;
/******************************************************************************
Display view template editor top.
******************************************************************************/
		case 'displayTopView':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			
			<?php
			if(isset($_GET['anywhereTag']))
			{
				print'&lt;'.$_GET['anywhereTag'].'&gt; - '.$anywhereTagDescriptions[$_GET['anywhereTag']];
			}
			elseif(isset($_GET['entryTag']))
			{
				print'&lt;'.$_GET['entryTag'].'&gt; - '.$entryTagDescriptions[$_GET['entryTag']];
			}
			else
			{
				print GUESTBOOK_NAME;
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display view template editor left.
******************************************************************************/
		case 'displayLeftView':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p>Anywhere:</p>
			
			<?php
			for($i=0;$i<count($anywhereTags);$i++)
			{
				print'<a href="admin.php?display=displayTopView&anywhereTag='.$anywhereTags[$i].'" target="top">'.$anywhereTags[$i].'</a><br />'."\r\n";
			}
			?>
			
			<p>Entry:</p>
			
			<?php
			for($i=0;$i<count($entryTags);$i++)
			{
				print'<a href="admin.php?display=displayTopView&entryTag='.$entryTags[$i].'" target="top">'.$entryTags[$i].'</a><br />'."\r\n";
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display view template editor right.
******************************************************************************/
		case 'displayRightView':
			$templates=new PYGTEMPLATES();
			
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p><a href="admin.php?display=templateAdmin" target="_top">Back to Administration Menu</a></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=editView" target="_top">
			<p>Header<br />
			<textarea name="post_headerTemplate" cols="90" rows="8" wrap="OFF" id="post_headerTemplate"><?php print pyg_htmlspecialchars($templates->get('viewHeader'));?></textarea>
			</p>
			<p>Entry<br />
			<textarea name="post_entryTemplate" cols="90" rows="8" wrap="OFF" id="post_entryTemplate"><?php print pyg_htmlspecialchars($templates->get('viewEntry'));?></textarea>
			</p>
			<p>Footer<br />
			<textarea name="post_footerTemplate" cols="90" rows="8" wrap="OFF" id="post_footerTemplate"><?php print pyg_htmlspecialchars($templates->get('viewFooter'));?></textarea>
			</p>
			<p><input type="submit" name="Submit" value="Submit" />
			<input type="reset" name="Submit2" value="Reset" />
			</p>
			</form>
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display sign template editor.
******************************************************************************/
		case 'signTemplateEditor':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			</head>
			<frameset rows="*" cols="150,*" border="0" framespacing="0">
				<frame src="admin.php?display=displayLeftSign" name="left" id="left" />
				<frameset rows="50,*" border="0" framespacing="0">
					<frame src="admin.php?display=displayTopSign" name="top" id="top" />
					<frame src="admin.php?display=displayRightSign" name="right" id="right" />
				</frameset>
			</frameset>
			<noframes>
			<body>
			</body>
			</noframes>
			</html>
			<?php
		break;
/******************************************************************************
Display sign template editor top.
******************************************************************************/
		case 'displayTopSign':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			
			<?php
			if(isset($_GET['anywhereTag']))
			{
				print'&lt;'.$_GET['anywhereTag'].'&gt; - '.$anywhereTagDescriptions_sign[$_GET['anywhereTag']];
			}
			else
			{
				print GUESTBOOK_NAME;
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display sign template editor left.
******************************************************************************/
		case 'displayLeftSign':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p>Anywhere:</p>
			
			<?php
			for($i=0;$i<count($anywhereTags_sign);$i++)
			{
				print'<a href="admin.php?display=displayTopSign&anywhereTag='.$anywhereTags_sign[$i].'" target="top">'.$anywhereTags_sign[$i].'</a><br />'."\r\n";
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display sign template editor right.
******************************************************************************/
		case 'displayRightSign':
			$templates=new PYGTEMPLATES();
			
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p><a href="admin.php?display=templateAdmin" target="_top">Back to Administration Menu</a></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=editSign" target="_top">
			<p>
			<textarea name="post_signTemplate" cols="90" rows="20" wrap="OFF"><?php print pyg_htmlspecialchars($templates->get('sign'));?></textarea>
			</p>
			<p>
			<input type="submit" name="Submit" value="Submit" />
			<input type="reset" name="Submit2" value="Reset" />
			</p>
			</form>
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display thanks template editor.
******************************************************************************/
		case'thanksTemplateEditor':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			</head>
			<frameset rows="*" cols="150,*" border="0" framespacing="0">
				<frame src="admin.php?display=displayLeftThanks" name="left" id="left" />
				<frameset rows="50,*" border="0" framespacing="0">
					<frame src="admin.php?display=displayTopThanks" name="top" id="top" />
					<frame src="admin.php?display=displayRightThanks" name="right" id="right" />
				</frameset>
			</frameset>
			<noframes>
			<body>
			</body>
			</noframes>
			</html>
			<?php
		break;
/******************************************************************************
Display thanks template editor top.
******************************************************************************/
		case 'displayTopThanks':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			
			<?php
			if(isset($_GET['anywhereTag']))
			{
				print'&lt;'.$_GET['anywhereTag'].'&gt; - '.$anywhereTagDescriptions_thanks[$_GET['anywhereTag']];
			}
			else
			{
				print GUESTBOOK_NAME;
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display thanks template editor left.
******************************************************************************/
		case 'displayLeftThanks':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p>Anywhere:</p>
			
			<?php
			for($i=0;$i<count($anywhereTags_thanks);$i++)
			{
				print'<a href="admin.php?display=displayTopThanks&anywhereTag='.$anywhereTags_thanks[$i].'" target="top">'.$anywhereTags_thanks[$i].'</a><br />'."\r\n";
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display thanks template editor right.
******************************************************************************/
		case 'displayRightThanks':
			$templates=new PYGTEMPLATES();
			
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p><a href="admin.php?display=templateAdmin" target="_top">Back to Administration Menu</a></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=editThanks" target="_top">
			<p>
			<textarea name="post_thanksTemplate" cols="90" rows="20" wrap="OFF"><?php print pyg_htmlspecialchars($templates->get('thanks'));?></textarea>
			</p>
			<p>
			<input type="submit" name="Submit" value="Submit" />
			<input type="reset" name="Submit2" value="Reset" />
			</p>
			</form>
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display thanks template editor.
******************************************************************************/
		case'loginTemplateEditor':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			</head>
			<frameset rows="*" cols="150,*" border="0" framespacing="0">
				<frame src="admin.php?display=displayLeftLogin" name="left" id="left" />
				<frameset rows="50,*" border="0" framespacing="0">
					<frame src="admin.php?display=displayTopLogin" name="top" id="top" />
					<frame src="admin.php?display=displayRightLogin" name="right" id="right" />
				</frameset>
			</frameset>
			<noframes>
			<body>
			</body>
			</noframes>
			</html>
			<?php
		break;
/******************************************************************************
Display login template editor top.
******************************************************************************/
		case 'displayTopLogin':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			
			<?php
			if(isset($_GET['anywhereTag']))
			{
				print'&lt;'.$_GET['anywhereTag'].'&gt; - '.$anywhereTagDescriptions_login[$_GET['anywhereTag']];
			}
			else
			{
				print GUESTBOOK_NAME;
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display login template editor left.
******************************************************************************/
		case 'displayLeftLogin':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p>Anywhere:</p>
			
			<?php
			for($i=0;$i<count($anywhereTags_login);$i++)
			{
				print'<a href="admin.php?display=displayTopLogin&anywhereTag='.$anywhereTags_login[$i].'" target="top">'.$anywhereTags_login[$i].'</a><br />'."\r\n";
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display login template editor right.
******************************************************************************/
		case 'displayRightLogin':
			$templates=new PYGTEMPLATES();
			
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p><a href="admin.php?display=templateAdmin" target="_top">Back to Administration Menu</a></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=editLoginTemplate" target="_top">
			<p>
			<textarea name="post_loginTemplate" cols="90" rows="20" wrap="OFF"><?php print pyg_htmlspecialchars($templates->get('login'));?></textarea>
			</p>
			<p>
			<input type="submit" name="Submit" value="Submit" />
			<input type="reset" name="Submit2" value="Reset" />
			</p>
			</form>
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display reply template editor.
******************************************************************************/
		case 'replyTemplateEditor':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			</head>
			<frameset rows="*" cols="150,*" border="0" framespacing="0">
				<frame src="admin.php?display=displayLeftReply" name="left" id="left" />
				<frameset rows="50,*" border="0" framespacing="0">
					<frame src="admin.php?display=displayTopReply" name="top" id="top" />
					<frame src="admin.php?display=displayRightReply" name="right" id="right" />
				</frameset>
			</frameset>
			<noframes>
			<body>
			</body>
			</noframes>
			</html>
			<?php
		break;
/******************************************************************************
Display reply template editor top.
******************************************************************************/
		case 'displayTopReply':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			
			<?php
			if(isset($_GET['anywhereTag']))
			{
				print'&lt;'.$_GET['anywhereTag'].'&gt; - '.$anywhereTagDescriptions_reply[$_GET['anywhereTag']];
			}
			else
			{
				print GUESTBOOK_NAME;
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display reply template editor left.
******************************************************************************/
		case 'displayLeftReply':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p>Anywhere:</p>
			
			<?php
			for($i=0;$i<count($anywhereTags_reply);$i++)
			{
				print'<a href="admin.php?display=displayTopReply&anywhereTag='.$anywhereTags_reply[$i].'" target="top">'.$anywhereTags_reply[$i].'</a><br />'."\r\n";
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display reply template editor right.
******************************************************************************/
		case 'displayRightReply':
			$templates=new PYGTEMPLATES();
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p><a href="admin.php?display=templateAdmin" target="_top">Back to Administration Menu</a></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=editReplyTemplate" target="_top">
			<p>
			<textarea name="post_replyTemplate" cols="90" rows="20" wrap="OFF" name="post_replyTemplate"><?php print pyg_htmlspecialchars($templates->get('reply'));?></textarea>
			</p>
			<p>
			<input type="submit" name="Submit" value="Submit" />
			<input type="reset" name="Submit2" value="Reset" />
			</p>
			</form>
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display error template editor.
******************************************************************************/
		case 'errorTemplateEditor':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			</head>
			<frameset rows="*" cols="150,*" border="0" framespacing="0">
				<frame src="admin.php?display=displayLeftError" name="left" id="left" />
				<frameset rows="50,*" border="0" framespacing="0">
					<frame src="admin.php?display=displayTopError" name="top" id="top" />
					<frame src="admin.php?display=displayRightError" name="right" id="right" />
				</frameset>
			</frameset>
			<noframes>
			<body>
			</body>
			</noframes>
			</html>
			<?php
		break;
/******************************************************************************
Display error template editor top.
******************************************************************************/
		case 'displayTopError':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			
			<?php
			if(isset($_GET['anywhereTag']))
			{
				print'&lt;'.$_GET['anywhereTag'].'&gt; - '.$anywhereTagDescriptions_error[$_GET['anywhereTag']];
			}
			elseif(isset($_GET['entryTag']))
			{
				print'&lt;'.$_GET['entryTag'].'&gt; - '.$errorTagDescriptions_error[$_GET['entryTag']];
			}
			else
			{
				print GUESTBOOK_NAME;
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display error template editor left.
******************************************************************************/
		case 'displayLeftError':
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p>Anywhere:</p>
			
			<?php
			for($i=0;$i<count($anywhereTags_error);$i++)
			{
				print'<a href="admin.php?display=displayTopError&anywhereTag='.$anywhereTags_error[$i].'" target="top">'.$anywhereTags_error[$i].'</a><br />'."\r\n";
			}
			?>
			
			<p>Error:</p>
			
			<?php
			for($i=0;$i<count($errorTags_error);$i++)
			{
				print'<a href="admin.php?display=displayTopError&entryTag='.$errorTags_error[$i].'" target="top">'.$errorTags_error[$i].'</a><br />'."\r\n";
			}
			?>
			
			</body>
			</html>
			<?php
		break;
/******************************************************************************
Display error template editor right.
******************************************************************************/
		case 'displayRightError':
			$templates=new PYGTEMPLATES();
			
			?>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title><?php print GUESTBOOK_NAME;?></title>
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
			<style type="text/css">
			<!--
			body {
				font-family: Arial, Helvetica, sans-serif;
				font-size: 8pt;
			}
			-->
			</style>
			</head>
			<body>
			<p><a href="admin.php?display=templateAdmin" target="_top">Back to Administration Menu</a></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=editError" target="_top">
			<p>Header<br />
			<textarea name="post_errorHeaderTemplate" cols="90" rows="8" wrap="OFF" id="post_errorHeaderTemplate"><?php print pyg_htmlspecialchars($templates->get('errorHeader'));?></textarea>
			</p>
			<p>Error<br />
			<textarea name="post_perErrorTemplate" cols="90" rows="8" wrap="OFF" id="post_perErrorTemplate"><?php print pyg_htmlspecialchars($templates->get('perError'));?></textarea>
			</p>
			<p>Footer<br />
			<textarea name="post_errorFooterTemplate" cols="90" rows="8" wrap="OFF" id="post_errorFooterTemplate"><?php print pyg_htmlspecialchars($templates->get('errorFooter'));?></textarea>
			</p>
			<p><input type="submit" name="Submit" value="Submit" />
			<input type="reset" name="Submit2" value="Reset" />
			</p>
			</form>
			</body>
			</html>
			<?php
		break;
/******************************************************************************
*******************************************************************************
*
* Display language administration screen.
*
*******************************************************************************
******************************************************************************/
		case'languageAdmin':
			print$adminHeader;
			
			?>
			<table width="650"  cellpadding="4" cellspacing="4" class="pyg_table">
			<tr>
			<td class="pyg_table_header">Language Administration</td>
			</tr>
			<tr>
			<td class="pyg_table_body">
			<table width="100%" cellspacing="0" cellpadding="0">
			<tr>
			<td valign="top">
			<form name="form1" id="form1" method="post" action="admin.php?action=updateMonth">
			<select name="post_monthNumber" id="post_monthNumber">
			<option value="1">01</option>
			<option value="2">02</option>
			<option value="3">03</option>
			<option value="4">04</option>
			<option value="5">05</option>
			<option value="6">06</option>
			<option value="7">07</option>
			<option value="8">08</option>
			<option value="9">09</option>
			<option value="10">10</option>
			<option value="11">11</option>
			<option value="12">12</option>
			</select>
			<input name="post_monthName" type="text" id="post_monthName" />
			<input name="Submit" type="submit" class="pyg_button" id="Submit" value="Update" />
			</form>        
			<p>
			
			<?php
			for($i=1;$i<=12;$i++)
			{
				print'Month '.str_pad($i,2,'0',STR_PAD_LEFT).': '.$options->get("month$i")."<br />\r\n";
			}
			?>
			
			</p>
			</td>
			<td valign="top">
			<form name="form2" id="form2" method="post" action="admin.php?action=updateDay">
			<select name="post_dayNumber" id="post_dayNumber">
			<option value="1">01</option>
			<option value="2">02</option>
			<option value="3">03</option>
			<option value="4">04</option>
			<option value="5">05</option>
			<option value="6">06</option>
			<option value="7">07</option>
			</select>
			<input name="post_dayName" type="text" id="post_dayName" />
			<input name="Submit2" type="submit" class="pyg_button" value="Update" />
			</form>
			
			<?php
			for($i=1;$i<=7;$i++)
			{
				print'Day '.str_pad($i,2,'0',STR_PAD_LEFT).': '.$options->get("day$i")."<br />\r\n";
			}
			?>
			
			</td>
			</tr>
			</table>
			<form name="form3" id="form3" method="post" action="admin.php?action=setErrorMessage">
			<select name="post_errorName">
			<option value="requiredFieldError">Required Field Error</option>
			<option value="longEntryError">Long Entry Error</option>
			<option value="IPError">Banned IP Error</option>
			<option value="badWordError">Bad Word Error</option>
			<option value="badStringError">Bad String Error</option>
			<option value="maxLinesError">Max Lines Error</option>
			</select>
			<input name="post_errorMessage" type="text" id="post_errorMessage" />
			<input name="Submit3" type="submit" class="pyg_button" value="Update" />
			</form>
			<p>
			Required Field Error Message: <?php print$options->get('requiredFieldError');?><br />
			Long Entry Error Message: <?php print$options->get('longEntryError');?><br />
			Banned IP Error Message: <?php print$options->get('IPError');?><br />
			Bad Word Error Message: <?php print$options->get('badWordError');?><br />
			Bad String Error Message: <?php print$options->get('badStringError');?><br />
			Max Lines Error Message: <?php print$options->get('maxLinesError');?><br />
			</p>
			</td>
			</tr>
			</table>
			<?php
			
			print$adminFooter;
		break;
/******************************************************************************
*******************************************************************************
*
* Display entries administration.
*
*******************************************************************************
******************************************************************************/
		case'adminEntries':
			print$adminHeader;

			?>
			<table width="650"  cellpadding="4" cellspacing="4" class="pyg_table">
			<tr>
			<td class="pyg_table_header">Entries Administration</td>
			</tr>
			</table>
			&nbsp;
			<table width="650"  cellpadding="4" cellspacing="4" class="pyg_table">
			<tr>
			<td width="33%" class="<?php if($_GET['status']=='active'){print'pyg_table_header_2';}else{print'pyg_table_body';}?>" align="center"><a href="admin.php?display=adminEntries&amp;status=active">Active</a></td>
			<td width="33%" class="<?php if($_GET['status']=='awaitingValidation'){print'pyg_table_header_2';}else{print'pyg_table_body';}?>" align="center"><a href="admin.php?display=adminEntries&amp;status=awaitingValidation">Awaiting Validation</a></td>
			<td width="33%" class="<?php if($_GET['status']=='deleted'){print'pyg_table_header_2';}else{print'pyg_table_body';}?>" align="center"><a href="admin.php?display=adminEntries&amp;status=deleted">Deleted</a></td>
			</tr>
			</table>
			&nbsp;
			<?php

			$DB=new PYGDB();
			
			if($options->get('entryOrder'))
			{
				$entryOrder='chronological';
			}
			else
			{
				$entryOrder='reversechronological';
			}
			
			switch($_GET['status'])
			{
				case'awaitingValidation':
					$rows=$DB->getRowsAwaitingValidation($entryOrder);
				break;
				case'deleted':
					$rows=$DB->getDeletedRows($entryOrder);
				break;
				default:
					$rows=$DB->getRows($entryOrder);
				break;
			}
			
			if(!count($rows))
			{
				?>
				<table width="100%" align="center" cellspacing="0">
				<tr>
				<td>
				<p style="color:#ffffff">There are no such entries in the database.</p>
				</td>
				</tr>
				</table>
				&nbsp;
				<?php
			}
			
			$totalEntries=count($rows);
			
			$entriesPerPage=$options->get('entriesPerPage');
			
			if($options->get('spanPages')&&$totalEntries)
			{
				/* Set beginning entry. */
				if(
					isset($_GET['beginningEntry'])&&				/* Must be set. */
					settype($_GET['beginningEntry'],'integer')&&	/* Must be an integer. */
					$_GET['beginningEntry']>0&&						/* Must be greater than zero. */
					$_GET['beginningEntry']<=$totalEntries			/* Must be less than or equal to the total number of entries. */
				)
				{
					/* Good. Do nothing. */
				}
				else
				{
					$_GET['beginningEntry']=1;
				}
			
				/* Set ending entry. */
				if(
					isset($_GET['endingEntry'])&&					/* Must be set. */
					settype($_GET['endingEntry'],'integer')&&		/* Must be an integer. */
					$_GET['endingEntry']>0&&						/* Must be greater than zero. */
					$_GET['endingEntry']>=$_GET['beginningEntry']&&	/* Must be greater than or equal to beginning entry. */
					$_GET['endingEntry']<=$totalEntries				/* Must be less than or equal to the total number of entries. */
					
				)
				{
					/* Good. Do nothing. */
				}
				elseif($_GET['beginningEntry']+$entriesPerPage-1<=$totalEntries)
				{
					$_GET['endingEntry']=$_GET['beginningEntry']+$entriesPerPage-1;
				}
				else
				{
					$_GET['endingEntry']=$totalEntries;
				}
			
				/* Set beginning entry for next page. */
				if($_GET['endingEntry']+1>$totalEntries)
				{
					$bNextPage=1;
				}
				else
				{
					$bNextPage=$_GET['endingEntry']+1;
				}
			
				/* Set ending entry for next page. */
				if($bNextPage+$entriesPerPage-1>$totalEntries)
				{
					$eNextPage=$totalEntries;
				}
				else
				{
					$eNextPage=$bNextPage+$entriesPerPage-1;
				}
			
				/* Set beginning entry for previous page. */
				if($_GET['beginningEntry']==1)
				{
					$bPreviousPage=$totalEntries-$entriesPerPage+1;
				}
				elseif($_GET['beginningEntry']-$entriesPerPage<1)
				{
					$bPreviousPage=1;
				}
				else
				{
					$bPreviousPage=$_GET['beginningEntry']-$entriesPerPage;
				}
			
				/* Set ending entry for previous page. */
				if($_GET['beginningEntry']==1)
				{
					$ePreviousPage=$totalEntries;
				}
				else
				{
					$ePreviousPage=$_GET['beginningEntry']-1;
				}
			
				$rows=array_slice($rows,$_GET['beginningEntry']-1,$_GET['endingEntry']-$_GET['beginningEntry']+1);
			}
			elseif(!$totalEntries)
			{
				$bPreviousPage=$bNextPage=$_GET['beginningEntry']=0;
			
				$ePreviousPage=$eNextPage=$_GET['endingEntry']=0;
			}
			else
			{
				$bPreviousPage=$bNextPage=$_GET['beginningEntry']=1;
			
				$ePreviousPage=$eNextPage=$_GET['endingEntry']=$totalEntries;
			}
			
			$bannedIPs=new PYGBANNEDIPS();
			
			$counter=0;
			
			$entriesHTML='';
			
			foreach($rows as $row)
			{
				$fieldNames=$DB->getColumnNames();
			
				/* Handle max word length limit. */
				for($i=0;$i<count($fieldNames);$i++)
				{
					$words=explode(' ',$row[$fieldNames[$i]]);
			
					for($j=0;$j<count($words);$j++)
					{
						$moreWords=explode("\r\n",$words[$j]);
			
						for($k=0;$k<count($moreWords);$k++)
						{
							$moreWords[$k]=trim(chunk_split($moreWords[$k],$options->get('maxWordLength'),' '));
						}
			
						$words[$j]=implode("\r\n",$moreWords);
					}
			
					$row[$fieldNames[$i]]=implode(' ',$words);
				}
			
				/* Handle entries containing HTML. */
				if(!$options->get('allowHTML'))
				{
					foreach($fieldNames as $fieldName)
					{
						$row[$fieldName]=pyg_htmlspecialchars($row[$fieldName]);
					}
				}
			
				/* Handle smilies in comments and reply. */
				if($options->get('smiliesEnabled')==1)
				{
					$smilies=new PYGSMILIES();
			
					foreach($smilies->get() as $smiley)
					{
						if($options->get('allowHTML'))
						{
							$row['comments']=str_replace($smiley['emoticon'],'<img border="0" src="'.$smiley['filename'].'" alt="" />',$row['comments']);
			
							$row['reply']=str_replace($smiley['emoticon'],'<img border="0" src="'.$smiley['filename'].'" alt="" />',$row['reply']);
						}
						else
						{
							$row['comments']=str_replace(pyg_htmlspecialchars($smiley['emoticon']),'<img border="0" src="'.$smiley['filename'].'" alt="" />',$row['comments']);
			
							$row['reply']=str_replace(pyg_htmlspecialchars($smiley['emoticon']),'<img border="0" src="'.$smiley['filename'].'" alt="" />',$row['reply']);
						}
					}
				}
			
				foreach($fieldNames as $fieldName)
				{
					$row[$fieldName]=str_replace("\r\n",'<br />',$row[$fieldName]);
				}
			
				$entry=<<<entryHTMLDelimiter
				<table width="650" align="center" cellspacing="1" bgcolor="#000000">
				<tr>
				<td style="background-image:url(grad1.gif)">
				<table width="100%" align="center" cellpadding="2" cellspacing="0">
				<tr>
				<td><p><number> - <month> <da>, <ye> <ho12>:<midd>:<sedd> <ampm></p></td>
				</tr>
				</table>
				</td>
				</tr>
				<tr>
				<td bgcolor="#ffffff">
				<table cellspacing="0" width="100%" cellpadding="2" bgcolor="#ffffff">
				<tr>
				<td width="15%" valign="top"><p>IP:</p></td>
				<td width="85%" valign="top"><p><ip></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Host Name:</p></td>
				<td width="85%" valign="top"><p><hostName></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Name:</p></td>
				<td width="85%" valign="top"><p><name></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Email:</p></td>
				<td width="85%" valign="top"><p><email></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Homepage:</p></td>
				<td width="85%" valign="top"><p><homepage></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Location:</p></td>
				<td width="85%" valign="top"><p><location></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Comments:</p></td>
				<td width="85%" valign="top"><p><comments></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Reply:</p></td>
				<td width="85%" valign="top"><p><reply></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Extra Field 1:</p></td>
				<td width="85%" valign="top"><p><extraField1></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Extra Field 2:</p></td>
				<td width="85%" valign="top"><p><extraField2></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Extra Field 3:</p></td>
				<td width="85%" valign="top"><p><extraField3></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Extra Field 4:</p></td>
				<td width="85%" valign="top"><p><extraField4></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Extra Field 5:</p></td>
				<td width="85%" valign="top"><p><extraField5></p></td>
				</tr>
				<tr>
				<td width="15%" valign="top"><p>Private?:</p></td>
				<td width="85%" valign="top"><p><private></p></td>
				</tr>
				</table>
				</td>
				</tr>
				<tr>
				<td style="background-image:url(grad1.gif)" align="right">
				<table cellpadding="2" cellspacing="0">
				<tr>
				<td>
				<p>
				Admin:
				<validateButton><replyButton><deleteButton><editButton><banButton><restoreButton>
				</p>
				</td>
				</tr>
				</table>
				</td>
				</tr>
				</table>
				&nbsp;
entryHTMLDelimiter;
			
				/* Parse tags. */
				$timestamp=$row['dateAndTime'];
				
				$months=array(
					$options->get('month1'),
					$options->get('month2'),
					$options->get('month3'),
					$options->get('month4'),
					$options->get('month5'),
					$options->get('month6'),
					$options->get('month7'),
					$options->get('month8'),
					$options->get('month9'),
					$options->get('month10'),
					$options->get('month11'),
					$options->get('month12')
				);
				
				$daysOfWeek=array(
					$options->get('day1'),
					$options->get('day2'),
					$options->get('day3'),
					$options->get('day4'),
					$options->get('day5'),
					$options->get('day6'),
					$options->get('day7')
				);
				
				$entry=str_replace('<ye>',date('Y',$timestamp),$entry);
				$entry=str_replace('<yedd>',date('y',$timestamp),$entry);
				$entry=str_replace('<mo>',date('n',$timestamp),$entry);
				$entry=str_replace('<modd>',date('m',$timestamp),$entry);
				$entry=str_replace('<month>',$months[date('n',$timestamp)-1],$entry);
				$entry=str_replace('<da>',date('j',$timestamp),$entry);
				$entry=str_replace('<dadd>',date('d',$timestamp),$entry);
				$entry=str_replace('<weekday>',$daysOfWeek[date('w',$timestamp)],$entry);
				$entry=str_replace('<ho12>',date('g',$timestamp),$entry);
				$entry=str_replace('<ho12dd>',date('h',$timestamp),$entry);
				$entry=str_replace('<ho>',date('G',$timestamp),$entry);
				$entry=str_replace('<hodd>',date('H',$timestamp),$entry);
				$entry=str_replace('<mi>',intval(date('i',$timestamp)),$entry);
				$entry=str_replace('<midd>',date('i',$timestamp),$entry);
				$entry=str_replace('<se>',intval(date('s',$timestamp)),$entry);
				$entry=str_replace('<sedd>',date('s',$timestamp),$entry);
				$entry=str_replace('<ampm>',date('a',$timestamp),$entry);
			
				if($options->get('entryNumbersOrder'))
				{
					$entry=str_replace('<number>',$totalEntries-($_GET['beginningEntry']+$counter++)+1,$entry);
				}
				else
				{
					$entry=str_replace('<number>',$_GET['beginningEntry']+$counter++,$entry);
				}
			
				$entry=str_replace('<name>',$row['name'],$entry);
			
				$entry=str_replace('<email>',$row['email'],$entry);
				
				$entry=str_replace('<homepage>',$row['homepage'],$entry);
			
				$entry=str_replace('<location>',$row['location'],$entry);
			
				$entry=str_replace('<comments>',$row['comments'],$entry);
				
				$entry=str_replace('<ip>',$row['ip'],$entry);
				
				if($options->get('hostNameByIP'))
				{
					$entry=str_replace('<hostName>',gethostbyaddr($row['ip']),$entry);
				}
				else
				{
					$entry=str_replace('<hostName>','Host Name By IP is not enabled.',$entry);
				}
				
				$entry=str_replace('<reply>',$row['reply'],$entry);
			
				$entry=str_replace('<extraField1>',$row['extraField1'],$entry);
				$entry=str_replace('<extraField2>',$row['extraField2'],$entry);
				$entry=str_replace('<extraField3>',$row['extraField3'],$entry);
				$entry=str_replace('<extraField4>',$row['extraField4'],$entry);
				$entry=str_replace('<extraField5>',$row['extraField5'],$entry);
			
				$entry=str_replace('<id>',$row['id'],$entry);
			
				/* Make delete button. */
				if($_GET['status']=='deleted')
				{
					$entry=str_replace('<deleteButton>','',$entry);
				}
				elseif($_GET['beginningEntry']==$totalEntries)
				{
					$entry=str_replace('<deleteButton>',"|\r\n<a href=\"admin.php?action=deleteEntry&amp;status={$_GET['status']}&amp;id={$row['id']}&amp;from=admin&amp;beginningEntry=$bPreviousPage\">Delete</a>\r\n",$entry);
				}
				else
				{
					$entry=str_replace('<deleteButton>',"|\r\n<a href=\"admin.php?action=deleteEntry&amp;status={$_GET['status']}&amp;id={$row['id']}&amp;from=admin&amp;beginningEntry={$_GET['beginningEntry']}\">Delete</a>\r\n",$entry);
				}
			
				/* Make edit button. */
				$entry=str_replace('<editButton>',"|\r\n<a href=\"admin.php?display=editEntryForm&amp;status={$_GET['status']}&amp;id={$row['id']}&amp;from=admin&amp;beginningEntry={$_GET['beginningEntry']}\">Edit</a>\r\n",$entry);
			
				/* Make reply URL. */
				$entry=str_replace('<replyButton>',"<a href=\"admin.php?display=replyForm&amp;status={$_GET['status']}&amp;id={$row['id']}&amp;from=admin&amp;beginningEntry={$_GET['beginningEntry']}\">Reply</a>\r\n",$entry);
			
				/* Make ban button. */
				if($bannedIPs->isBanned($row['ip']))
				{
					$entry=str_replace('<banButton>',"|\r\n<a href=\"admin.php?action=unban&amp;status={$_GET['status']}&amp;ip={$row['ip']}&amp;beginningEntry={$_GET['beginningEntry']}\">Un-ban</a>",$entry);
				}
				else
				{
					$entry=str_replace('<banButton>',"|\r\n<a href=\"admin.php?action=ban&amp;status={$_GET['status']}&amp;ip={$row['ip']}&amp;beginningEntry={$_GET['beginningEntry']}\">Ban</a>",$entry);
				}
				
				/* Make validate button. */
				if($_GET['status']=='awaitingValidation')
				{
					$entry=str_replace('<validateButton>',"<a href=\"admin.php?action=makeActive&amp;status=awaitingValidation&amp;id={$row['id']}&amp;beginningEntry={$_GET['beginningEntry']}\">Validate</a>\r\n|\r\n",$entry);
				}
				else
				{
					$entry=str_replace('<validateButton>','',$entry);
				}
				
				/* Make restore button. */
				if($_GET['status']=='deleted')
				{
					$entry=str_replace('<restoreButton>',"\r\n|\r\n<a href=\"admin.php?action=makeActive&amp;status=deleted&amp;id={$row['id']}&amp;beginningEntry={$_GET['beginningEntry']}\">Restore</a>",$entry);
				}
				else
				{
					$entry=str_replace('<restoreButton>','',$entry);
				}
				
				/* Display private status. */
				if($row['private'])
				{
					$entry=str_replace('<private>','Yes',$entry);
				}
				else
				{
					$entry=str_replace('<private>','No',$entry);
				}
				
				$entriesHTML.=$entry;
			}
			
			$headerTemplate=<<<headerTemplateDelimiter
			<table width="100%" align="center" cellspacing="0">
			<tr>
			<td>
			<p style="color:#FFFFFF">Currently Viewing <beginning> - <ending> of <total></p>
			</td>
			<td align="right">
			<p>
			<a href="<prevURL>"><span style="color:#FFFFFF">Previous</span></a>
			<a href="<nextURL>"><span style="color:#FFFFFF">Next</span></a>
			</p>
			</td>
			</tr>
			</table>
			&nbsp;
headerTemplateDelimiter;

			$footerTemplate=<<<footerTemplateDelimiter
			<table width="100%" align="center" cellspacing="0">
			<tr>
			<td>
			<p style="color:#FFFFFF">Currently Viewing <beginning> - <ending> of <total></p>
			</td>
			<td align="right">
			<p>
			<a href="<prevURL>"><span style="color:#FFFFFF">Previous</span></a>
			<a href="<nextURL>"><span style="color:#FFFFFF">Next</span></a>
			</p>
			</td>
			</tr>
			</table>
footerTemplateDelimiter;
			
			$buffer=$headerTemplate.$entriesHTML.$footerTemplate;
			
			/* Additional tags to be parsed. Can appear anywhere in HTML. */
			if($options->get('entryNumbersOrder'))
			{
				$buffer=str_replace('<beginning>',$totalEntries-$_GET['beginningEntry']+1,$buffer);
				$buffer=str_replace('<ending>',$totalEntries-$_GET['endingEntry']+1,$buffer);
			}
			else
			{
				$buffer=str_replace('<beginning>',$_GET['beginningEntry'],$buffer);
				$buffer=str_replace('<ending>',$_GET['endingEntry'],$buffer);
			}
			
			$buffer=str_replace('<total>',$totalEntries,$buffer);
			$buffer=str_replace('<bNextPage>',$bNextPage,$buffer);
			$buffer=str_replace('<bPreviousPage>',$bPreviousPage,$buffer);
			$buffer=str_replace('<eNextPage>',$eNextPage,$buffer);
			$buffer=str_replace('<ePreviousPage>',$ePreviousPage,$buffer);
			$buffer=str_replace('<nextURL>','admin.php?display=adminEntries&amp;status='.$_GET['status'].'&amp;beginningEntry='.$bNextPage.'&amp;endingEntry='.$eNextPage,$buffer);
			$buffer=str_replace('<prevURL>','admin.php?display=adminEntries&amp;status='.$_GET['status'].'&amp;beginningEntry='.$bPreviousPage.'&amp;endingEntry='.$ePreviousPage,$buffer);
			
			print($buffer);

			print$adminFooter;
		break;
/******************************************************************************
*******************************************************************************
*
* Display edit entry form.
*
*******************************************************************************
******************************************************************************/
		case'editEntryForm':
			$DB=new PYGDB();
			
			$entry=$DB->select($_GET['id']);
			
			print$adminHeader;

			?>				
			<table width="650" cellpadding="4" cellspacing="4" class="pyg_table">
			<tr>
			<td class="pyg_table_header">Edit Entry</td>
			</tr>
			<tr>
			<td class="pyg_table_body">
			<form name="form1" id="form1" method="post" action="admin.php?status=<?php print$_GET['status'];?>&amp;from=<?php print$_GET['from'];?>&amp;action=editEntry&amp;beginningEntry=<?php print$_GET['beginningEntry'];?>">
			<p><input name="Submit" type="submit" class="pyg_button" value="Save Changes" />
			<input name="Reset" type="reset" class="pyg_button" value="Reset" />
			</p>
			<p><input name="id" type="hidden" id="id" value="<?php print$entry['id'];?>" />
			<input name="status" type="radio" value="0" <?php if($entry['status']==0){print'checked="checked" ';}?>/>
			Awaiting Validation <br />
			<input name="status" type="radio" value="1" <?php if($entry['status']==1){print'checked="checked" ';}?>/>
			Active<br />
			<input name="status" type="radio" value="2" <?php if($entry['status']==2){print'checked="checked" ';}?>/>
			Deleted</p>
			<?php $timeInfo=getdate($entry['dateAndTime']);?>
			<table>
			<tr>
			<td>Year</td>
			<td><input name="year" type="text" id="year" value="<?php print$timeInfo['year'];?>" /></td>
			</tr>
			<tr>
			<td>Month</td>
			<td><input name="month" type="text" id="month" value="<?php print$timeInfo['mon'];?>" /></td>
			</tr>
			<tr>
			<td>Day</td>
			<td><input name="day" type="text" id="day" value="<?php print$timeInfo['mday'];?>" /></td>
			</tr>
			<tr>
			<td>Hour</td>
			<td><input name="hour" type="text" id="hour" value="<?php print$timeInfo['hours'];?>" /></td>
			</tr>
			<tr>
			<td>Minute</td>
			<td><input name="minute" type="text" id="minute" value="<?php print$timeInfo['minutes'];?>" /></td>
			</tr>
			<tr>
			<td>Second</td>
			<td><input name="second" type="text" id="second" value="<?php print$timeInfo['seconds'];?>" /></td>
			</tr>
			</table>
			<p>I.P.<br />
			<textarea name="ip" cols="50" rows="2" id="ip"><?php print $entry['ip'];?></textarea>
			</p>
			<p>Name<br />
			<textarea name="name" cols="50" rows="2" id="name"><?php print $entry['name'];?></textarea>
			</p>
			<p>Email<br />
			<textarea name="email" cols="50" rows="2" id="email"><?php print $entry['email'];?></textarea>
			</p>
			<p>Homepage<br />
			<textarea name="homepage" cols="50" rows="2" id="homepage"><?php print $entry['homepage'];?></textarea>
			</p>
			<p>Location<br />
			<textarea name="location" cols="50" rows="2" id="location"><?php print $entry['location'];?></textarea>
			</p>
			<p>Comments<br />
			<textarea name="comments" cols="50" rows="2" id="comments"><?php print $entry['comments'];?></textarea>
			</p>
			<p>Extra Field 1<br />
			<textarea name="extraField1" cols="50" rows="2" id="extraField1"><?php print $entry['extraField1'];?></textarea>
			</p>
			<p>Extra Field 2<br />
			<textarea name="extraField2" cols="50" rows="2" id="extraField2"><?php print $entry['extraField2'];?></textarea>
			</p>
			<p>Extra Field 3<br />
			<textarea name="extraField3" cols="50" rows="2" id="extraField3"><?php print $entry['extraField3'];?></textarea>
			</p>
			<p>Extra Field 4<br />
			<textarea name="extraField4" cols="50" rows="2" id="extraField4"><?php print $entry['extraField4'];?></textarea>
			</p>
			<p>Extra Field 5<br />
			<textarea name="extraField5" cols="50" rows="2" id="extraField5"><?php print $entry['extraField5'];?></textarea>
			</p>
			<p><input name="private" type="checkbox" id="private" value="1" <?php if($entry['private']){print'checked="checked" ';}?>/>
			Private
			</p>
			<p>Reply<br />
			<textarea name="reply" cols="50" rows="2" id="reply" ><?php print $entry['reply'];?></textarea>
			</p>
			<p><input name="Submit" type="submit" class="pyg_button" value="Save Changes" />
			<input name="Reset" type="reset" class="pyg_button" value="Reset" />
			</p>
			</form>
			</td>
			</tr>
			</table>
			<?php

			print$adminFooter;
		break;
/******************************************************************************
*******************************************************************************
*
* Display reply form.
*
*******************************************************************************
******************************************************************************/
		case'replyForm':
			print$adminHeader;
			
			$DB=new PYGDB();
			
			$entry=$DB->select($_GET['id']);
			
			?>
			<table width="650" cellpadding="4" cellspacing="4" class="pyg_table">
			<tr>
			<td class="pyg_table_header">Reply To Entry</td>
			</tr>
			<tr>
			<td class="pyg_table_body">
			<form name="form1" id="form1" method="post" action="admin.php?status=<?php print$_GET['status'];?>&amp;from=<?php print$_GET['from'];?>&amp;action=reply&amp;id=<?php print$_GET['id'];?>&amp;beginningEntry=<?php print$_GET['beginningEntry'];?>">
			<p>Reply<br />
			<textarea name="reply" id="reply" cols="50"><?php print$entry['reply'];?></textarea>
			</p>
			<p><input type="submit" name="Submit" value="Submit" />
			<input type="reset" name="Reset" value="Reset" />
			</p>
			</form>
			</td>
			</tr>
			</table>
			<?php
			
			print$adminFooter;
		break;
/******************************************************************************
*******************************************************************************
*
* Display other options.
*
*******************************************************************************
******************************************************************************/
		case'otherAdmin':
			print$adminHeader;
			
			?>
			<table width="650" cellpadding="4" cellspacing="4" class="pyg_table">
			<tr>
			<td class="pyg_table_header">Other</td>
			</tr>
			<tr>
			<td class="pyg_table_body">
			<p>Email Options</p>
			<p>Email Notify: <a href="admin.php?action=toggleEmailNotification">
			<?php
			if($options->get('emailNotification'))
			{
				print"On\r\n";
			}
			else
			{
				print"Off\r\n";
			}
			?>
			</a>
			</p>
			<p>Email Address: <?php print$options->get('adminEmail');?></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=setAdminEmail">
			<input name="post_adminEmail" type="text" id="post_adminEmail" />
			<input name="Submit" type="submit" class="pyg_button" id="Submit" value="Update" />
			</form>
			<hr />
			<p>Tools</p>
			<p>
			<?php
			/* Populate tool list. */
			$toolList='';
			
			if(isset($_SERVER['PHP_SELF']))
			{
				$chunks=explode('/',dirname($_SERVER['PHP_SELF']));
			
				$directoryName=$chunks[count($chunks)-1];
				
				if(is_dir("../$directoryName"))
				{
					if($handle=@opendir("../$directoryName"))
					{
						while(false!==($file=readdir($handle)))
						{
							if(substr($file,0,5)=='tool.'&&substr($file,strlen($file)-4,4)=='.php')
							{
								$toolList.="<a href=\"$file\">".substr($file,5,strlen($file)-9)."</a><br />";
							}
						}
					}
				}
			}
			
			if(strlen($toolList))
			{
				print$toolList;
			}
			else
			{
				print'There are no tools present.';
			}
			
			/* End: Populate tool list. */
			?>
			</p>
			<hr />
			<p><a href="admin.php?action=resetPassword">Reset Password</a></p>
			</td>
			</tr>
			</table>
			<?php
			
			print$adminFooter;
		break;
/******************************************************************************
*******************************************************************************
*
* Display view administration.
*
*******************************************************************************
******************************************************************************/
		case'viewAdmin':
			print$adminHeader;
			
			?>
			<table width="650" cellpadding="4" cellspacing="4" class="pyg_table">
			<tr><td class="pyg_table_header">View Page Administration</td></tr>
			<tr>
			<td class="pyg_table_body">
			<table width="100%" cellspacing="0" cellpadding="0">
			<tr>
			<td width="50%" valign="top">
			<p>Entry Display Order: <a href="admin.php?action=toggleEntryOrder">
			<?php
			if($options->get('entryOrder'))
			{
				print'Chronological';
			}
			else
			{
				print'Reverse Chronological';
			}
			?>
			</a></p>
			<p>Span Pages: <a href="admin.php?action=toggleSpanPages">
			<?php
			if($options->get('spanPages'))
			{
				print'On';
			}
			else
			{
				print'Off';
			}
			?>
			</a></p>
			<p>Allow HTML: <a href="admin.php?action=toggleAllowHTML">
			<?php
			if($options->get('allowHTML'))
			{
				print'On';
			}
			else
			{
				print'Off';
			}
			?>
			</a></p>
			<p>Private Placeholders: <a href="admin.php?action=togglePrivatePlaceholders">
			<?php
			if($options->get('privatePlaceholders'))
			{
				print'On';
			}
			else
			{
				print'Off';
			}
			?>
			</a></p>
			<p>Entry Numbers Order: <a href="admin.php?action=toggleEntryNumbersOrder">
			<?php
			if($options->get('entryNumbersOrder'))
			{
				print'Descending';
			}
			else
			{
				print'Ascending';
			}
			?>
			</a></p>
			<p>Smilies: <a href="admin.php?action=toggleSmilies">
			<?php
			if($options->get('smiliesEnabled'))
			{
				print'On';
			}
			else
			{
				print'Off';
			}
			?>
			</a></p>
			<p>Host Name By IP: <a href="admin.php?action=toggleHostName">
			<?php
			if($options->get('hostNameByIP'))
			{
				print'On';
			}
			else
			{
				print'Off';
			}
			?>
			</a></p>
			</td>
			<td valign="top">
			<p>If guestbook is empty, go to</p>
			<p><?php print$options->get('emptyGoTo');?></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=setEmptyGoTo">
			<input name="emptyGoTo" type="text" size="10" />
			<input name="Submit" type="submit" class="pyg_button" value="Update" />
			</form>
			
			<hr />
			
			<p>Max Word Length (characters)</p>
			<p><?php print$options->get('maxWordLength');?></p>
			<form name="form2" id="form2" method="post" action="admin.php?action=setMaxWordLength">
			<input name="maxWordLength" type="text" size="10" />
			<input name="Submit2" type="submit" class="pyg_button" value="Update" />
			</form>
			
			<hr />
			
			<p>Entries Per Page</p>
			<p><?php print$options->get('entriesPerPage');?></p>
			<form name="form3" id="form3" method="post" action="admin.php?action=setEntriesPerPage">
			<input name="entriesPerPage" type="text" size="10" />
			<input name="Submit3" type="submit" class="pyg_button" value="Update" />
			</form>
			</td>
			</tr>
			<tr>
			<td colspan="2">
			<hr />
			<form name="form4" id="form4" method="post" action="admin.php?action=addSmiley">
			<table width="100%" cellspacing="0" cellpadding="0">
			<tr>
			<td width="20%">Smilies<br /><br /></td>
			<td width="20%">&nbsp;</td>
			<td width="20%">&nbsp;</td>
			<td width="20%">&nbsp;</td>
			<td width="20%">&nbsp;</td>
			</tr>
			<tr>
			<td>
			<p>Emoticon</p>
			<p><input name="emoticon" type="text" size="10" /></p>
			<p>&nbsp;</p>
			</td>
			<td>
			<p>Filename</p>
			<p><input name="filename" type="text" size="10" /></p>
			<p>&nbsp;</p>
			</td>
			<td>
			<p>Advanced</p>
			<p><input name="advanced" type="text" size="10" /></p>
			<p>&nbsp;</p>
			</td>
			<td>
			<p>&nbsp;</p>
			<p><input name="Submit4" type="submit" class="pyg_button" value="Add" /></p>
			<p>&nbsp;</p>
			</td>
			<td>&nbsp;</td>
			</tr>
			<?php
			$smilies=new PYGSMILIES();
			
			foreach($smilies->get() as $smiley)
			{
				print"<tr>\r\n";
				print"<td>{$smiley['emoticon']}</td>\r\n";
				print"<td>{$smiley['filename']}</td>\r\n";
				print"<td>{$smiley['advanced']}</td>\r\n";
				print"<td><img src=\"{$smiley['filename']}\"></td>\r\n";
				print"<td><a href=\"admin.php?action=removeSmiley&ID={$smiley['id']}\">Remove</a></td>\r\n";
				print"</tr>\r\n";
			}
			?>
			</table>
			</form>
			</td>
			</tr>
			</table>
			</td>
			</tr>
			</table>
			<?php
			
			print$adminFooter;

		break;
/******************************************************************************
*******************************************************************************
*
* Display sign administration.
*
*******************************************************************************
******************************************************************************/
		default:
			print$adminHeader;
			
			?>
			<table width="650" cellpadding="4" cellspacing="4" class="pyg_table">
			<tr><td class="pyg_table_header">Sign Page Administration</td></tr>
			<tr>
			<td class="pyg_table_body">
			<table width="100%" cellpadding="0" cellspacing="0">
			<tr valign="top">
			<td>
			
			<p>Required Fields</p>
			
			<p>
			<?php
			$fields=new PYGFIELDS();
			
			$fieldNames=$fields->getNames();
			
			foreach($fieldNames as $fieldName)
			{
				if($fields->required($fieldName))
				{
					print"<b><a href=\"admin.php?action=toggleRequired&field=$fieldName\">$fieldName</a></b><br />\r\n";
				}
				else
				{
					print"<a href=\"admin.php?action=toggleRequired&field=$fieldName\">$fieldName</a><br />\r\n";
				}
			}
			?>
			</p>
			
			<hr />
			
			<p>Validate Entries: <a href="admin.php?action=toggleEntryValidation">
			<?php
			if($options->get('validationRequired'))
			{
				print'On';
			}
			else
			{
				print'Off';
			}
			?>
			</a>
			</p>
			
			<hr />
			
			<p>Time Offset (seconds)</p>
			<p><?php print$options->get('timeOffset'); ?></p>
			<form name="form1" id="form1" method="post" action="admin.php?action=setTimeOffset">
			<input name="seconds" type="text" size="10" />
			<input name="Submit" type="submit" class="pyg_button" value="Update" />
			</form>
			
			<hr />
			
			<p>Max Entry Length (characters)</p>
			<p><?php print$options->get('maxEntryLength');?></p>
			<form name="form2" id="form2" method="post" action="admin.php?action=setMaxEntryLength">
			<input name="characters" type="text" size="10" />
			<input name="Submit2" type="submit" class="pyg_button" value="Update" />
			</form>
			
			<hr />
			
			<p>Max Number of Lines</p>
			<p><?php print$options->get('maxLines');?></p>
			<form name="form2" id="form2" method="post" action="admin.php?action=setMaxLines">
			<input name="post_lines" type="text" size="10" />
			<input name="Submit2" type="submit" class="pyg_button" value="Update" />
			</form>
			
			<hr />
			
			<p>After sign, go to</p>
			<p><?php print$options->get('signGoTo');?></p>
			<form name="form2" id="form2" method="post" action="admin.php?action=setSignGoTo">
			<input name="signGoTo" type="text" size="10" />
			<input name="Submit2" type="submit" class="pyg_button" value="Update" />
			</form>
			
			<hr />
			
			<p>Turing Protection: <a href="admin.php?action=toggleTuringProtection">
			<?php
			if($options->get('turingProtection'))
			{
				print'On';
			}
			else
			{
				print'Off';
			}
			?>
			</a>
			</p>
			
			</td>
			<td>
			<p>Banned IP Addresses</p>
			<form name="form3" id="form3" method="post" action="admin.php?action=ban">
			<input name="ip" type="text" size="10" />
			<input name="Submit3" type="submit" class="pyg_button" value="Add" />
			</form>
			<p>
			<?php
			$bannedIPs=new PYGBANNEDIPS();
			
			foreach($bannedIPs->get() as $bannedIP)
			{
				print"<a href=\"admin.php?action=unban&ip=$bannedIP&from=signAdmin\">$bannedIP</a><br />\r\n";
			}
			?>
			</p>
			</td>
			<td>
			<p>Bad Words</p>
			<form name="form3" id="form3" method="post" action="admin.php?action=addBadWord">
			<input name="badWord" type="text" size="10" />
			<input name="Submit32" type="submit" class="pyg_button" value="Add" />
			</form>
			<p>
			<?php
			$badWords=new PYGBADWORDS();
			
			foreach($badWords->get() as $badWord)
			{
				print"<a href=\"admin.php?action=removeBadWord&badWord=$badWord\">$badWord</a><br />\r\n";
			}
			?>
			</p>
			</td>
			<td>
			<p>Bad Strings</p>
			<form name="form3" id="form3" method="post" action="admin.php?action=addBadString">
			<input name="badString" type="text" size="10" />
			<input name="Submit33" type="submit" class="pyg_button" value="Add" />
			</form>
			<p>
			<?php
			$badStrings=new PYGBADSTRINGS();
			
			foreach($badStrings->get() as $badString)
			{
				print"<a href=\"admin.php?action=removeBadString&badString=$badString\">$badString</a><br />";
			}
			?>
			</p>
			</td>
			</tr>
			</table>
			</td>
			</tr>
			</table>
			<?php
			
			print$adminFooter;
		break;
	}
}
else
{
	header('location: admin.php?display=signAdmin');
}
?>